commit d40b619026bc96201e99ff093608c20dd3816867
Author: freddy77 <freddy77>
Date:   Tue Mar 11 08:42:30 2008 +0000

    fix auto-commit off before connection

diff --git a/ChangeLog b/ChangeLog
index f49e197..127da9b 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Tue Mar 11 09:42:04 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c: fix auto-commit off before connection
+
 Tue Mar 11 09:36:11 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/encodings.pl: fix a problem with cvs and branches
 
@@ -203,4 +206,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2499 2008/03/11 08:36:41 freddy77 Exp $
+$Id: ChangeLog,v 1.2500 2008/03/11 08:42:30 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 190efbc..57d078c 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.474 2008/03/07 10:57:54 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.475 2008/03/11 08:42:30 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -224,6 +224,9 @@ change_autocommit(TDS_DBC * dbc, int state)
 			ODBC_RETURN(dbc, SQL_ERROR);
 		}
 		dbc->attr.autocommit = state;
+	} else {
+		/* if not connected we will change auto-commit after login */
+		dbc->attr.autocommit = state;
 	}
 	ODBC_RETURN_(dbc);
 }
@@ -358,7 +361,11 @@ odbc_connect(TDS_DBC * dbc, TDSCONNECTION * connection)
 		dbc->cursor_support = 1;
 
 	if (dbc->attr.txn_isolation != SQL_TXN_READ_COMMITTED)
-		if (change_txn(dbc, dbc->attr.txn_isolation) != SQL_SUCCESS)
+		if (!SQL_SUCCEEDED(change_txn(dbc, dbc->attr.txn_isolation)))
+			ODBC_RETURN_(dbc);
+
+	if (dbc->attr.autocommit != SQL_AUTOCOMMIT_ON)
+		if (!SQL_SUCCEEDED(change_autocommit(dbc, dbc->attr.autocommit)))
 			ODBC_RETURN_(dbc);
 
 	/* this overwrite any error arrived (wanted behavior, Sybase return error for conversion errors) */

